// Spider Model

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glut.h>
#include <math.h>
#include <stdio.h>
#include "mex.h"
// performance measurement:
#include <sys/types.h>
#include <sys/timeb.h>
static const unsigned int DELAY = 1;

// Define a constant for the value of PI
#define GL_PI 3.1415f

// Rotation amounts
static GLfloat xRot = 0.0f;
static GLfloat yRot = 0.0f;
static GLfloat Stacks = 20;
static GLfloat Slices = 20;

// These are needed to control animation time steps
int contFlag = 1;
int timeStep = 0;
int old_timeStep;
int max_timeStep = 120;
int stop = 1;
static const GLfloat RIGHT = 1.0;
static const GLfloat LEFT = -1.0;
static const GLfloat FEMALE = 1.0;
static const GLfloat MALE = 0.0;
GLfloat gender = FEMALE;
GLfloat female_side = LEFT;
GLfloat side = RIGHT;

GLfloat inputParams[5000];
int numParams;

// default colors 
GLfloat red = 0.6;
GLfloat green = 0.7;
GLfloat blue = 0.0;
GLfloat ambience_red = 0.3f;
GLfloat	ambience_green = 0.3f;
GLfloat	ambience_blue = 0.3f;
GLfloat	ambience_alpha = 1.0f;

GLfloat	diffuse_red = 0.7f;
GLfloat	diffuse_green = 0.7f;
GLfloat	diffuse_blue = 0.7f;
GLfloat	diffuse_alpha = 1.0f;


GLfloat	specular_red = 0.7f;
GLfloat	specular_green = 0.7f;
GLfloat	specular_blue = 0.7f;
GLfloat	specular_alpha = 1.0f;

GLfloat	background_red = 0.3f;
GLfloat	background_green = 0.3f;
GLfloat	background_blue = 0.0f;
GLfloat	background_alpha = 1.0f;
GLuint        SpiderTexture;    /* Spider texture image */
	
// Build geometry of the abdomen:
// CONE attached to thorax =
GLfloat ab_thorTopRad = 7.0;
GLfloat ab_thorBotRad = 12.0;
GLfloat ab_thorLength = 15;

//change to a SPHERE w/ connections to CONES instead:
GLfloat ab_topSphereRad = 12.0;
// main CONE of abdomen trunk =
GLfloat ab_trunkTopRad = 10;
GLfloat ab_trunkBotRad = 7;
GLfloat ab_trunkLength = 12;
// possible to put sphere here to get the bottom section flatter?
GLfloat ab_sphereRad = 7;
// end CONE of abdomen =
GLfloat ab_endTopRad = 7;
GLfloat ab_endBotRad = 5;
GLfloat ab_endLength = 11;
// cap the end with a sphere:
GLfloat ab_endSphereRad = 5;
// Also, want it to be a bit flatter, eliptical shaped (set it to half for now):
GLfloat ab_widthScale = 1.5;
GLfloat ab_lengthScale = 1.0;
GLfloat ab_heightScale = 1.0;


// Build geometry of the thorax:
// Sphere to close off the attachment to abdomen:
GLfloat th_abSphere = 15;
// CONE attached to abdomen =
GLfloat th_abTopRad = 7;
GLfloat th_abBotRad = 14;
GLfloat th_abLength = 9;
// SPHERE for middle of thorax
GLfloat th_sphereRad = 16;
// CONE attached to head =
GLfloat th_headTopRad = 16;
GLfloat th_headBotRad = 14;
GLfloat th_headLength = 4;	
// Also, want it to be a bit flatter, eliptical shaped (set it to half for now):
GLfloat th_heightScale = 1.0;
GLfloat th_widthScale = 1.5;
GLfloat th_lengthScale = 1.0;

// Build geometry of the head:
// Sphere to close off the attachment to abdomen:
GLfloat h_abSphere = 15;
// CYLINDER attached to abdomen =
GLfloat h_cylTopRad = 15;
GLfloat h_cylBotRad = 10;
GLfloat h_cylLength = 13;
// CONE attached to thorax =
GLfloat h_endTopRad = 12;
GLfloat h_endBotRad = 4;
GLfloat h_endLength = 9;	
// Also, want it to be a bit flatter, eliptical shaped (set it to half for now):
GLfloat h_widthScale = 1.0;
GLfloat h_lengthScale = 1.0;
GLfloat h_heightScale = 1.0;
// Build the geometry of the legs:
// front legs:
GLfloat f_seg1 = 45.0;
GLfloat f_seg2 = 56.0;
GLfloat f_seg3 = 34.0;
GLfloat f_seg4 = 22.0;
GLfloat f_radius1 = 4.0;
GLfloat f_radius2 = 4.0;
GLfloat f_radius3 = 2.0;
GLfloat f_radius4 = 1.0;

// tracks right leg timeSteps
GLfloat rf_ang1 = -20.0;
GLfloat rf_ang2 = 40.0;
GLfloat rf_ang3 = 20.0;
GLfloat rf_ang4 = -20.0;

GLfloat newrf_ang1 = rf_ang1;
GLfloat newrf_ang2 = rf_ang2;
GLfloat newrf_ang3 = rf_ang3;
GLfloat newrf_ang4 = rf_ang4;

GLfloat lf_ang1 = rf_ang1;
GLfloat lf_ang2 = rf_ang2;
GLfloat lf_ang3 = rf_ang3;
GLfloat lf_ang4 = rf_ang4;

// tracks left leg timeSteps
GLfloat newlf_ang1 = lf_ang1;
GLfloat newlf_ang2 = lf_ang2;
GLfloat newlf_ang3 = lf_ang3;
GLfloat newlf_ang4 = lf_ang4;

GLfloat fleg_seg1_red = red;
GLfloat fleg_seg1_green = green;
GLfloat fleg_seg1_blue = blue;
GLfloat fleg_seg2_red = red;
GLfloat fleg_seg2_green = green;
GLfloat fleg_seg2_blue = blue;
GLfloat fleg_seg3_red = red;
GLfloat fleg_seg3_green = green;
GLfloat fleg_seg3_blue = blue;
GLfloat fleg_seg4_red = red;
GLfloat fleg_seg4_green = green;
GLfloat fleg_seg4_blue = blue;


// second legs (near front):
GLfloat s_seg1 = 22.0;
GLfloat s_seg2 = 40.0;
GLfloat s_seg3 = 34.0;
GLfloat s_seg4 = 16.0;
GLfloat s_radius1 = 4.0;
GLfloat s_radius2 = 3.0;
GLfloat s_radius3 = 2.0;
GLfloat s_radius4 = 1.0;
GLfloat s_ang1 = -20.0;
GLfloat s_ang2 = 40.0;
GLfloat s_ang3 = 20.0;
GLfloat s_ang4 = -20.0;

GLfloat newrs_ang1 = s_ang1;
GLfloat newrs_ang2 = s_ang2;
GLfloat newrs_ang3 = s_ang3;
GLfloat newrs_ang4 = s_ang4;

GLfloat ls_ang1 = s_ang1;
GLfloat ls_ang2 = s_ang2;
GLfloat ls_ang3 = s_ang3;
GLfloat ls_ang4 = s_ang4;

GLfloat newls_ang1 = ls_ang1;
GLfloat newls_ang2 = ls_ang2;
GLfloat newls_ang3 = ls_ang3;
GLfloat newls_ang4 = ls_ang4;

GLfloat sleg_seg1_red = red;
GLfloat sleg_seg1_green = green;
GLfloat sleg_seg1_blue = blue;
GLfloat sleg_seg2_red = red;
GLfloat sleg_seg2_green = green;
GLfloat sleg_seg2_blue = blue;
GLfloat sleg_seg3_red = red;
GLfloat sleg_seg3_green = green;
GLfloat sleg_seg3_blue = blue;
GLfloat sleg_seg4_red = red;
GLfloat sleg_seg4_green = green;
GLfloat sleg_seg4_blue = blue;

// third legs (near back);
GLfloat t_seg1 = 28.0; 
GLfloat t_seg2 = 40.0;
GLfloat t_seg3 = 34.0;
GLfloat t_seg4 = 16.0;
GLfloat t_radius1 = 4.0;
GLfloat t_radius2 = 3.0;
GLfloat t_radius3 = 2.0;
GLfloat t_radius4 = 1.0;
GLfloat t_ang1 = -20.0;
GLfloat t_ang2 = 40.0;
GLfloat t_ang3 = 20.0;
GLfloat t_ang4 = -20.0;
GLfloat tleg_seg1_red = red;
GLfloat tleg_seg1_green = green;
GLfloat tleg_seg1_blue = blue;
GLfloat tleg_seg2_red = red;
GLfloat tleg_seg2_green = green;
GLfloat tleg_seg2_blue = blue;
GLfloat tleg_seg3_red = red;
GLfloat tleg_seg3_green = green;
GLfloat tleg_seg3_blue = blue;
GLfloat tleg_seg4_red = red;
GLfloat tleg_seg4_green = green;
GLfloat tleg_seg4_blue = blue;
// back legs:
GLfloat b_seg1 = 45.0;
GLfloat b_seg2 = 54.0;
GLfloat b_seg3 = 40.0;
GLfloat b_seg4 = 16.0;
GLfloat b_radius1 = 4.0;
GLfloat b_radius2 = 3.0;
GLfloat b_radius3 = 2.0;
GLfloat b_radius4 = 1.0;
GLfloat b_ang1 = -25.0;
GLfloat b_ang2 = 45.0;
GLfloat b_ang3 = 20.0;
GLfloat b_ang4 = -20.0;

GLfloat bleg_seg1_red = red;
GLfloat bleg_seg1_green = green;
GLfloat bleg_seg1_blue = blue;
GLfloat bleg_seg2_red = red;
GLfloat bleg_seg2_green = green;
GLfloat bleg_seg2_blue = blue;
GLfloat bleg_seg3_red = red;
GLfloat bleg_seg3_green = green;
GLfloat bleg_seg3_blue = blue;
GLfloat bleg_seg4_red = red;
GLfloat bleg_seg4_green = green;
GLfloat bleg_seg4_blue = blue;



void RenderAbdomen(void)
{
	GLUquadric	*ab_Section;
	ab_Section = gluNewQuadric();

	glRotatef(-10, 0.0, 0.0, 1.0);
	glRotatef(90, 0.0, 1.0, 0.0);
	glScalef(ab_widthScale, ab_heightScale, ab_lengthScale);

	glTranslatef(0.0, 0.0, -5.0);
	// closest to thorax
	glPushMatrix();
		gluCylinder(ab_Section, ab_thorTopRad, ab_thorBotRad, ab_thorLength,
			Stacks, Slices);
	glPopMatrix();

	// Bulk of thorax
	glTranslatef(0.0, 0.0, ab_thorLength);
	glPushMatrix();
		glTranslatef(0.0, 0.0, ab_thorLength*2/5);
		glScalef(1.0, 1.0, 1.5);
		gluSphere(ab_Section, ab_topSphereRad, Stacks, Slices);
	glPopMatrix();

	glTranslatef(0.0, 0.0, ab_topSphereRad*4/3);
	glPushMatrix();
		gluCylinder(ab_Section, ab_trunkTopRad, ab_trunkBotRad, ab_trunkLength,
			Stacks, Slices);
	glPopMatrix();

	// Insert sphere here to see if we can make the bottom part flatter:
	glTranslatef(0.0, 0.0, ab_trunkLength);
	glPushMatrix();
		glScalef(1.0, 1.0, .6);
		gluSphere(ab_Section, ab_sphereRad,	Stacks, Slices);
	glPopMatrix();

	glRotatef(10, 1.0, 0.0, 0.0);
	// End of abdomen
	glPushMatrix();
		gluCylinder(ab_Section, ab_endTopRad, ab_endBotRad, ab_endLength,
			Stacks, Slices);
		// cap off the end with a sphere:
		glTranslatef(0.0, 0.0, ab_endLength*3/4);
		gluSphere(ab_Section, ab_endSphereRad, Stacks, Slices);
	glPopMatrix();

}


// Every pair of legs should be different.  But not every leg
// Unsure how many parameters are allowed for each leg. :-/
// but we will need:
// for the leg segments: the length of 4 segments
//						 the base radius of the 4 segments
//						 the top radius of the 4 segments
//		* Note: - the last 2 leg segments have constant values.
//				  therefore, we may be able to hard code them (thereby eliminating
//				  4 parameters)
//				- Also, the base radius of consecutive leg segments will be
//				  the same size as the previous segment's top radius
//				  This allows us to deduce that baseRad2 = topRad1
// for the joints: the spherical size of each joint.  We can calculate
//				   the joint sizes through the top radii.
// for the angles between each segment: the degree of 4 angles
void RenderLeg(GLfloat seg1, GLfloat seg2, GLfloat seg3, GLfloat seg4,
	GLfloat radius1, GLfloat radius2, GLfloat radius3, GLfloat radius4,
	GLfloat ang1, GLfloat ang2, GLfloat ang3, GLfloat ang4, GLfloat frontDir,
	GLfloat backDir, GLfloat red1, GLfloat green1, GLfloat blue1,
	GLfloat red2, GLfloat green2, GLfloat blue2,
	GLfloat red3, GLfloat green3, GLfloat blue3,
	GLfloat red4, GLfloat green4, GLfloat blue4)
{
	// Fixed values to reduce the # of parameters needed
	GLfloat joint = 0.0;

	GLUquadricObj *legSegment;
	GLUquadricObj *legJoint;
	legJoint = gluNewQuadric();
	legSegment = gluNewQuadric();

	glPushMatrix();
	glRotatef(90.0, 0.0, 1.0, 0.0);
	glRotatef(ang1, 1.0, 0.0, 0.0);

	// leg segment 1: segment closest to body of spider
	glPushMatrix();
		glColor3f(red1, green1, blue1);
		
		gluSphere(legJoint, radius1, 20, 20);
		gluCylinder(legSegment, radius1, radius2, seg1, 20, 20);
		
		// Change color back to original settings
		glColor3f(red, green, blue);
	glPopMatrix();

	glTranslatef(0.0, 0.0, seg1);
	glRotatef(ang2, 1.0, 0.0, 0.0);

	// leg segment 2: next largest leg segment
	// we want to rotate the 2nd segment towards each other.
	// for the front two pairs of legs, we want to go in the 
	// front direction.  (back will be set to 0.  and viceversa for
	// the back 2 pairs of legs).
	glRotatef(frontDir*20, 0.0, 1.0, 0.0);
	glRotatef(-1*backDir*20, 0.0, 1.0, 0.0);

	glPushMatrix();
		glColor3f(red2, green2, blue2);
		joint = radius2 + 0.5;
		gluSphere(legJoint, joint, 20, 20);
		gluCylinder(legSegment, radius2, radius3, seg2, 20, 20);
		glColor3f(red, green, blue);
	glPopMatrix();

	glTranslatef(0.0, 0.0, seg2);
	glRotatef(ang3, 1.0, 0.0, 0.0);

	// leg segment 3. becomes significantly thinner
	glPushMatrix();
		glColor3f(red3, green3, blue3);
		joint = radius3 + 0.5;
		gluSphere(legJoint, joint, 20.0, 20.0);
		gluCylinder(legSegment, radius3, radius4, seg3, 20.0, 20.0);
		glColor3f(red, green, blue);
	glPopMatrix();

	glTranslatef(0.0, 0.0, seg3);
	glRotatef(ang4, 1.0, 0.0, 0.0);
	// leg segment 4. last leg segments
	glPushMatrix();
		glColor3f(red4, green4, blue4);
		joint = radius4 + 0.5;
		gluSphere(legJoint, joint, 20.0, 20.0);
		gluCylinder(legSegment, radius4, radius4, seg4, 20.0, 20.0);
		glColor3f(red, green, blue);
	glPopMatrix();
	glPopMatrix();

}

// Create 4 legs on each side.  Needs to be symmetric, so pass in yAxis
// as positive or negative for each side
void RenderLegs() {

	int legCount = 4;
	int bodyFlag = 0;
	glScalef(1.2, 1.2, 1.2);
	GLfloat deltaAng1 = 0;
	GLfloat deltaAng2 = 0;
	GLfloat deltaAng3 = 0;
	GLfloat deltaAng4 = 0;

	// Move legs away from origin
	glTranslatef(0.0, 0.0, side*5.0*th_widthScale);

	// 1st (front) pair of legs
	glPushMatrix();

		// Move out of the body some more, so that bottom view
		// of legs is clearer
		glTranslatef(0.0, 0.0, side*4.0*h_widthScale);
		glRotatef(-30.0, 0.0, side, 0.0);

		if (side == RIGHT) {
			if (timeStep != -1) {
				// Move the leg in increments of timesteps.  
				if (contFlag && timeStep < max_timeStep) {
					if (((gender == FEMALE) && (female_side == RIGHT)) ||
						(gender == MALE)) {
						newrf_ang1 = rf_ang1 - inputParams[timeStep+155];
						newrf_ang2 = rf_ang2 + inputParams[timeStep+ max_timeStep +155];
						newrf_ang3 = rf_ang3 + inputParams[timeStep+(max_timeStep*2)+155];
						newrf_ang4 = rf_ang4 + inputParams[timeStep+(max_timeStep*3)+155];
					}
				} else {
					// re-animate from the beginning:
					timeStep = 0;
					newrf_ang1 = rf_ang1;
					newrf_ang2 = rf_ang2;
					newrf_ang3 = rf_ang3;
					newrf_ang4 = rf_ang4;
				}
			}
			RenderLeg(f_seg1, f_seg2, f_seg3, f_seg4,
				f_radius1, f_radius2, f_radius3, f_radius4,
				newrf_ang1, newrf_ang2, newrf_ang3, newrf_ang4, side, 0,
				fleg_seg1_red, fleg_seg1_green, fleg_seg1_blue,
				fleg_seg2_red, fleg_seg2_green, fleg_seg2_blue,
				fleg_seg3_red, fleg_seg3_green, fleg_seg3_blue,
				fleg_seg4_red, fleg_seg4_green, fleg_seg4_blue);
		} else {
			if (timeStep != -1) {
			
				// Move the leg in increments of timesteps.  
				if (contFlag && timeStep < max_timeStep) {				
					if (((gender == FEMALE) && (female_side == LEFT)) ||
						(gender == MALE)) {
						newlf_ang1 = lf_ang1 - inputParams[timeStep+155+(max_timeStep*4)];
						newlf_ang2 = lf_ang2 + inputParams[timeStep+155+(max_timeStep*5)];
						newlf_ang3 = lf_ang3 + inputParams[timeStep+155+(max_timeStep*6)];
						newlf_ang4 = lf_ang4 + inputParams[timeStep+155+(max_timeStep*7)];
					}
				} else {
					// re-animate from the beginning:
					timeStep = 0;
					newlf_ang1 = lf_ang1;
					newlf_ang2 = lf_ang2;
					newlf_ang3 = lf_ang3;
					newlf_ang4 = lf_ang4;
				}
			}
			RenderLeg(f_seg1, f_seg2, f_seg3, f_seg4,
				f_radius1, f_radius2, f_radius3, f_radius4,
				newlf_ang1, newlf_ang2, newlf_ang3, newlf_ang4, side, 0,
				fleg_seg1_red, fleg_seg1_green, fleg_seg1_blue,
				fleg_seg2_red, fleg_seg2_green, fleg_seg2_blue,
				fleg_seg3_red, fleg_seg3_green, fleg_seg3_blue,
				fleg_seg4_red, fleg_seg4_green, fleg_seg4_blue);
		}
	glPopMatrix();
	
	// 2nd pair of legs
	glPushMatrix();
		glTranslatef(-10.0*th_widthScale, 0.0, 0.0);
		glRotatef(-65.0, 0.0, side, 0.0);
		if (side == RIGHT) {
			if (timeStep != -1) {

				// Move the leg in increments of timesteps.  
				if (contFlag && timeStep < max_timeStep) {
					timeStep = timeStep + 1;
					if ((gender == FEMALE) && (female_side == RIGHT)) {
						newrs_ang1 = s_ang1 - inputParams[timeStep+155];
						newrs_ang2 = s_ang2 + inputParams[timeStep+ max_timeStep +155];
						newrs_ang3 = s_ang3 + inputParams[timeStep+(max_timeStep*2)+155];
						newrs_ang4 = s_ang4 + inputParams[timeStep+(max_timeStep*3)+155];
					} 
				} else {
					// re-animate from the beginning:
					timeStep = 0;
					newrs_ang1 = s_ang1;
					newrs_ang2 = s_ang2;
					newrs_ang3 = s_ang3;
					newrs_ang4 = s_ang4;
			
				}
			}
			RenderLeg(s_seg1, s_seg2, s_seg3, s_seg4,
				s_radius1, s_radius2, s_radius3, s_radius4,
				newrs_ang1, newrs_ang2, newrs_ang3, newrs_ang4, side, 0,
				sleg_seg1_red, sleg_seg1_green, sleg_seg1_blue,
				sleg_seg2_red, sleg_seg2_green, sleg_seg2_blue,
				sleg_seg3_red, sleg_seg3_green, sleg_seg3_blue,
				sleg_seg4_red, sleg_seg4_green, sleg_seg4_blue);
		} else {
			if (timeStep != -1) {
				// Move the leg in increments of timesteps.  
				if (contFlag && timeStep < max_timeStep) {
					timeStep = timeStep + 1;				
					if ((gender == FEMALE) && (female_side == LEFT)) {
						newls_ang1 = s_ang1 - inputParams[timeStep+155+(max_timeStep*4)];
						newls_ang2 = s_ang2 + inputParams[timeStep+155+(max_timeStep*5)];
						newls_ang3 = s_ang3 + inputParams[timeStep+155+(max_timeStep*6)];
						newls_ang4 = s_ang4 + inputParams[timeStep+155+(max_timeStep*7)];
					} 
				} else {
					// re-animate from the beginning:
					timeStep = 0;
					newls_ang1 = s_ang1;
					newls_ang2 = s_ang2;
					newls_ang3 = s_ang3;
					newls_ang4 = s_ang4;
				}
			}
			RenderLeg(s_seg1, s_seg2, s_seg3, s_seg4,
				s_radius1, s_radius2, s_radius3, s_radius4,
				newls_ang1, newls_ang2, newls_ang3, newls_ang4, side, 0,
				sleg_seg1_red, sleg_seg1_green, sleg_seg1_blue,
				sleg_seg2_red, sleg_seg2_green, sleg_seg2_blue,
				sleg_seg3_red, sleg_seg3_green, sleg_seg3_blue,
				sleg_seg4_red, sleg_seg4_green, sleg_seg4_blue);
		} 


			
	glPopMatrix();

	// 3rd pair oflegs
	glPushMatrix();
	glTranslatef(-15.0*ab_lengthScale, 0.0, 0.0);
		glRotatef(-110.0, 0.0, side, 0.0);
		RenderLeg(t_seg1, t_seg2, t_seg3, t_seg4,
			t_radius1, t_radius2, t_radius3, t_radius4,
			t_ang1, t_ang2, t_ang3, t_ang4, 0, side,
			tleg_seg1_red, tleg_seg1_green, tleg_seg1_blue,
			tleg_seg2_red, tleg_seg2_green, tleg_seg2_blue,
			tleg_seg3_red, tleg_seg3_green, tleg_seg3_blue,
			tleg_seg4_red, tleg_seg4_green, tleg_seg4_blue);
	glPopMatrix();

	// 4th (hind) pair of legs
	glPushMatrix();
		glTranslatef(0.0, 0.0, side*2.0);
		glTranslatef(-25.0*ab_lengthScale, 0.0, 0.0);
		glRotatef(-145.0, 0.0, side, 0.0);

		RenderLeg(b_seg1, b_seg2, b_seg3, b_seg4,
			b_radius1, b_radius2, b_radius3, b_radius4,
			b_ang1, b_ang2, b_ang3, b_ang4, 0, side,
			bleg_seg1_red, bleg_seg1_green, bleg_seg1_blue,
			bleg_seg2_red, bleg_seg2_green, bleg_seg2_blue,
			bleg_seg3_red, bleg_seg3_green, bleg_seg3_blue,
			bleg_seg4_red, bleg_seg4_green, bleg_seg4_blue);
	glPopMatrix();
}




void RenderThorax(void)
{
	GLUquadric	*th_Section;
	th_Section = gluNewQuadric();


	glTranslatef(-10.0*th_lengthScale, 0.0, 0.0);
	glRotatef(10, 0.0, 0.0, 1.0);
	glRotatef(-90, 0.0, 1.0, 0.0);

	glScalef(th_widthScale, th_heightScale, th_lengthScale);

	// Connect to abdomen
	glPushMatrix();
		glRotatef(-10, 1.0, 0.0, 0.0);
		glTranslatef(0.0, 0.0, -8.0);
		glScalef(1.0, 1.0, 1.2);
		gluCylinder(th_Section, th_abTopRad, th_abBotRad, th_abLength,
			Stacks, Slices);
	glPopMatrix();

	// Connect to head later
	glTranslatef(0.0, 0.0, th_abLength);
	glPushMatrix();
		glScalef(1.0, 1.0, 0.9);
		glTranslatef(0.0, 2.0, 2.0);
		gluSphere(th_Section, th_sphereRad, Stacks, Slices);
	glPopMatrix();

}

void RenderHead(void) 
{
	GLUquadric	*h_Section;
	h_Section = gluNewQuadric();

	glRotatef(-10, 1.0, 0.0, 0.0);
	glTranslatef(0.0, 2.0, 0.0);
	glScalef(h_widthScale, h_heightScale, h_lengthScale);
	glPushMatrix();
		gluCylinder(h_Section, h_cylTopRad, h_cylBotRad, h_cylLength,
			Stacks, Slices);
	glPopMatrix();

	glTranslatef(0.0, 0.0, h_cylLength-1);
	glPushMatrix();
		gluCylinder(h_Section, h_endTopRad, h_endBotRad, h_endLength,
			Stacks, Slices);
	glPopMatrix();

}

// xDistance determines how far apart the 2 spinnerets will be.
void RenderSpinnerets(GLfloat rotationAngle, GLfloat xDistance,
					  GLfloat outerRotationAngle, GLfloat headRad)
{
	GLUquadric	*sp_Section;
	sp_Section = gluNewQuadric();

	// Build geometry of the head:
	// Sphere to close off the attachment to abdomen:
	GLfloat sp_abSphere = 15;

	// CYLINDER attached to head =
	GLfloat sp_cylTopRad = 2;
	GLfloat sp_cylBotRad = 2;
	GLfloat sp_cylLength = 20;

	GLfloat sp_jointSphereRad = 2;

	// CYLINDER =
	GLfloat sp_tipTopRad = 2;
	GLfloat sp_tipBotRad = 4;
	GLfloat sp_tipLength = 10;
	
	GLfloat sp_sphereRad = 5;

	// CONE attached to cyl =
	GLfloat sp_endTopRad = 4.0;
	GLfloat sp_endBotRad = 0.5;
	GLfloat sp_endLength = 8;
	
	// Also, want it to be a bit flatter, eliptical shaped (set it to half for now):
	GLfloat sp_widthScale = 0.7;

	glRotatef(side*outerRotationAngle, 0.0, 1.0, 0.0);
	glRotatef(2*outerRotationAngle, 1.0, 0.0, 0.0);

	// Move spinnerets away from origin
	glTranslatef(side*headRad, 0.0, 0.0);

	// Closest to Head
	glPushMatrix();
		gluCylinder(sp_Section, sp_cylTopRad, sp_cylBotRad, sp_cylLength,
			Stacks, Slices);
	glPopMatrix();

	glTranslatef(0.0, 0.0, sp_cylLength);
	glPushMatrix();
		gluSphere(sp_Section, sp_jointSphereRad, Stacks, Slices);
	glPopMatrix();

	glRotatef(outerRotationAngle*3/2, 1.0, 0.0, 0.0);
	glPushMatrix();
		gluCylinder(sp_Section, sp_cylTopRad, sp_cylBotRad, sp_cylLength/3,
			Stacks, Slices);
	glPopMatrix();

	glTranslatef(0.0, 0.0, sp_cylLength/3);
	glPushMatrix();
		gluCylinder(sp_Section, sp_tipTopRad, sp_tipBotRad, sp_tipLength,
			Stacks, Slices);
	glPopMatrix();

	glTranslatef(0.0, 0.0, sp_tipLength);
	glPushMatrix();
		glScalef(sp_widthScale, 1.0, 1.6);
		gluSphere(sp_Section, sp_sphereRad, Stacks, Slices);
	glPopMatrix();

	// Need to tilt the ends of the spinnerets in towards each other
	glTranslatef(0.0, 0.0, sp_cylLength/4);
	glTranslatef(-1*side*1.0, 0.0, -1 * sp_cylLength/40);
	glRotatef(-1*side*outerRotationAngle*3/2, 0.0, 1.0, 0.0);
	glPushMatrix();
		gluSphere(sp_Section, sp_sphereRad, Stacks, Slices);
		gluCylinder(sp_Section, sp_endTopRad, sp_endBotRad, sp_endLength,
			Stacks, Slices);
	glPopMatrix();

}
// This function does any needed initialization on the rendering
// context. 
void SetupRC()
{
	GLfloat	ambientLight[] =
		{ambience_red, ambience_green, ambience_blue, ambience_alpha};
	GLfloat diffuseLight[] =
		{diffuse_red, diffuse_green, diffuse_blue, diffuse_alpha};
	GLfloat specularLight[] = 
		{specular_red, specular_green, specular_blue, specular_alpha};

	glEnable(GL_DEPTH_TEST);
	glFrontFace(GL_CCW);
	glEnable(GL_CULL_FACE);
	
	glLightfv(GL_LIGHT0, GL_AMBIENT, ambientLight);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuseLight);
	glLightfv(GL_LIGHT0, GL_SPECULAR, specularLight);
	glEnable(GL_LIGHT0);
	GLfloat specref[] = {1.0, 1.0, 1.0, 1.0};

	// Enable Color tracking
	glEnable(GL_COLOR_MATERIAL);

	glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
	glMaterialfv(GL_FRONT, GL_SPECULAR, specref);
	glMateriali(GL_FRONT, GL_SHININESS, 128);
	glEnable(GL_LIGHTING);

	// Set drawing color to green
	glClearColor(
		background_red, background_green, background_blue, background_alpha);
}
// Called to draw scene
void RenderScene(void)
{
	// Clear the window with current clearing color
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
	glColor3f(red, green, blue);
	glScalef(.7, .7, .7);

	// Save matrix state and do the rotation	
	glRotatef(xRot, 1.0f, 0.0f, 0.0f);
	glRotatef(yRot, 0.0f, 1.0f, 0.0f);

	// Need to push and pop body parts in order to reset the modelview matrix
	// using the stack.  This will allow for rotation while viewing, while
	// placing the objects in the correct position relative to the origin.

	glPushMatrix();
		side = RIGHT;
		RenderLegs();
	glPopMatrix();
	glPushMatrix();
		side = LEFT;
		RenderLegs();
	glPopMatrix();

	glRotatef(180, 0.0, 1.0, 0.0);
	glTranslatef(20.0, 10.0, 0.0);

	// Create the Body
	glPushMatrix();
		RenderAbdomen();
	glPopMatrix();
	
	// Create the thorax and head sections
	glPushMatrix();	
		RenderThorax();
		RenderHead();
		glPushMatrix();
			side = LEFT;
			RenderSpinnerets(110.0, -4.0, 20.0, 5.0);
		glPopMatrix();
		glPushMatrix();
			side = RIGHT;
			RenderSpinnerets(70.0, 4.0, 20.0, 5.0);
		glPopMatrix();
	glPopMatrix();
	SetupRC();
	glPopMatrix();

	// redraw the spider again for animation.
	glutPostRedisplay();

	glutSwapBuffers();
	
}




void SpecialKeys(int key, int x, int y)
{
	if(key == GLUT_KEY_UP)
		xRot-= 5.0f;

	if(key == GLUT_KEY_DOWN)
		xRot += 5.0f;

	if(key == GLUT_KEY_LEFT)
		yRot -= 5.0f;

	if(key == GLUT_KEY_RIGHT)
		yRot += 5.0f;

	if(key > 356.0f)
		xRot = 0.0f;

	if(key < -1.0f)
		xRot = 355.0f;

	if(key > 356.0f)
		yRot = 0.0f;

	if(key < -1.0f)
		yRot = 355.0f;

	// Refresh the Window
	glutPostRedisplay();
}


void ChangeSize(int w, int h)
{
	GLfloat nRange = 125.0f;

	// Prevent a divide by zero
	if(h == 0)
		h = 1;

	// Set Viewport to window dimensions
    glViewport(0, 0, w, h);

	// Reset projection matrix stack
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	// Establish clipping volume (left, right, bottom, top, near, far)
    if (w <= h) 
		glOrtho (-nRange, nRange, -nRange*h/w, nRange*h/w, -nRange, nRange);
    else 
		glOrtho (-nRange*w/h, nRange*w/h, -nRange, nRange, -nRange, nRange);

	// Reset Model view matrix stack
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}


void setColors() {
	red = inputParams[0];
	green = inputParams[1];
	blue = inputParams[2];
}

void setAmbienceColor() {
	ambience_red = inputParams[3];
	ambience_green = inputParams[4];
	ambience_blue = inputParams[5];
	ambience_alpha = inputParams[6];
}

void setDiffuseColor() {
	diffuse_red = inputParams[7];
	diffuse_green = inputParams[8];
	diffuse_blue = inputParams[9];
	diffuse_alpha = inputParams[10];

}

void setSpecularColor() {
	specular_red = inputParams[11];
	specular_green = inputParams[12];
	specular_blue = inputParams[13];
	specular_alpha = inputParams[14];
}

void setBackgroundColor() {
	background_red = inputParams[15];
	background_green = inputParams[16];
	background_blue = inputParams[17];
	background_alpha = inputParams[18];
}

void setAbdomenParams() {
	// we know args 4 - 16 pertain to abdomen
	ab_thorTopRad = inputParams[19];
	ab_thorBotRad = inputParams[20];
	ab_thorLength = inputParams[21];

	ab_topSphereRad = inputParams[23];
	ab_trunkTopRad = inputParams[24];
	ab_trunkBotRad = inputParams[25];
	ab_trunkLength = inputParams[26];
	ab_sphereRad = inputParams[27];
	ab_endTopRad = inputParams[28];
	ab_endBotRad = inputParams[29];	
	ab_endLength = inputParams[30];
	ab_endSphereRad = inputParams[31];
	ab_widthScale = inputParams[32];
	ab_heightScale = inputParams[33];
	ab_lengthScale = inputParams[34];
}

void setThoraxParams() {
	th_abSphere = inputParams[35];
	th_abTopRad = inputParams[36];
	th_abBotRad = inputParams[37];
	th_abLength = inputParams[38];
	th_sphereRad = inputParams[39];
	th_headTopRad = inputParams[40];
	th_headBotRad = inputParams[41];
	th_headLength = inputParams[42];
	th_widthScale = inputParams[43];
	th_heightScale = inputParams[44];
	th_lengthScale = inputParams[45];
}
void setHeadParams() {
	h_abSphere = inputParams[46];
	h_cylTopRad	= inputParams[47];	
	h_cylBotRad = inputParams[48];
	h_cylLength = inputParams[49];
	h_endTopRad = inputParams[50];
	h_endBotRad = inputParams[51];
	h_endLength = inputParams[52];	
	h_widthScale = inputParams[53];
	h_heightScale = inputParams[54];
	h_lengthScale = inputParams[55];
}
void setLegParams() {
	// front legs
	f_seg1 = inputParams[56];
	f_seg2 = inputParams[57];
	f_seg3 = inputParams[58];
	f_seg4 = inputParams[59];
	f_radius1 = inputParams[60];
	f_radius2 = inputParams[61];
	f_radius3 = inputParams[62];
	f_radius4 = inputParams[63];
	rf_ang1 = inputParams[64];
	rf_ang2 = inputParams[65];
	rf_ang3 = inputParams[66];
	rf_ang4 = inputParams[67];

	// set to the same as right leg segments:
	// need these separate variables though when the right leg starts to move
	lf_ang1 = inputParams[64];
	lf_ang2 = inputParams[65];
	lf_ang3 = inputParams[66];
	lf_ang4 = inputParams[67];

	// set color to same as right leg segments:
	fleg_seg1_red = inputParams[68];
	fleg_seg1_green = inputParams[69];
	fleg_seg1_blue = inputParams[70];
	fleg_seg2_red = inputParams[71];
	fleg_seg2_green = inputParams[72];
	fleg_seg2_blue = inputParams[73];
	fleg_seg3_red = inputParams[74];
	fleg_seg3_green = inputParams[75];
	fleg_seg3_blue = inputParams[76];
	fleg_seg4_red = inputParams[77];
	fleg_seg4_green = inputParams[78];
	fleg_seg4_blue = inputParams[79];
	
	// second legs (near front):
	s_seg1 = inputParams[80];
	s_seg2 = inputParams[81];
	s_seg3 = inputParams[82];
	s_seg4 = inputParams[83];
	s_radius1 = inputParams[84]; 
	s_radius2 = inputParams[85];
	s_radius3 = inputParams[86];
	s_radius4 = inputParams[87];
	s_ang1 = inputParams[88];
	s_ang2 = inputParams[89];
	s_ang3 = inputParams[90];
	s_ang4 = inputParams[91];
	sleg_seg1_red = inputParams[92];
	sleg_seg1_green = inputParams[93];
	sleg_seg1_blue = inputParams[94];
	sleg_seg2_red = inputParams[95];
	sleg_seg2_green = inputParams[96];
	sleg_seg2_blue = inputParams[97];
	sleg_seg3_red = inputParams[98];
	sleg_seg3_green = inputParams[99];
	sleg_seg3_blue = inputParams[100];
	sleg_seg4_red = inputParams[101];
	sleg_seg4_green = inputParams[102];
	sleg_seg4_blue = inputParams[103];
	// skip numbers 92-103 - saving for color of second leg segment


	// third legs (near back)
	t_seg1 = inputParams[104];
	t_seg2 = inputParams[105];
	t_seg3 = inputParams[106];
	t_seg4 = inputParams[107];
	t_radius1 = inputParams[108];
	t_radius2 = inputParams[109];
	t_radius3 = inputParams[110];
	t_radius4 = inputParams[111];
	t_ang1 = inputParams[112];
	t_ang2 = inputParams[113];
	t_ang3 = inputParams[114];
	t_ang4 = inputParams[115];

	tleg_seg1_red = inputParams[116];
	tleg_seg1_green = inputParams[117];
	tleg_seg1_blue = inputParams[118];
	tleg_seg2_red = inputParams[119];
	tleg_seg2_green = inputParams[120];
	tleg_seg2_blue = inputParams[121];
	tleg_seg3_red = inputParams[122];
	tleg_seg3_green = inputParams[123];
	tleg_seg3_blue = inputParams[124];
	tleg_seg4_red = inputParams[125];
	tleg_seg4_green = inputParams[126];
	tleg_seg4_blue = inputParams[127];
	// skip numbers 116-127 - saving for color of third leg segment


	// back legs:
	b_seg1 = inputParams[128];	
	b_seg2 = inputParams[129];
	b_seg3 = inputParams[130];
	b_seg4 = inputParams[131];
	b_radius1 = inputParams[132];
	b_radius2 = inputParams[133];
	b_radius3 = inputParams[134];
	b_radius4 = inputParams[135];
	b_ang1 = inputParams[136];
	b_ang2 = inputParams[137];
	b_ang3 = inputParams[138];
	b_ang4 = inputParams[139];

	bleg_seg1_red = inputParams[140];
	bleg_seg1_green = inputParams[141];
	bleg_seg1_blue = inputParams[142];
	bleg_seg2_red = inputParams[143];
	bleg_seg2_green = inputParams[144];
	bleg_seg2_blue = inputParams[145];
	bleg_seg3_red = inputParams[146];
	bleg_seg3_green = inputParams[147];
	bleg_seg3_blue = inputParams[148];
	bleg_seg4_red = inputParams[149];
	bleg_seg4_green = inputParams[150];
	bleg_seg4_blue = inputParams[151];
	
}

// This will start and stop the spider movement depending on the parameter passed in
void setTimeStep() {
	max_timeStep = inputParams[152];
}


void setGender() {
	gender = inputParams[153];
}

void setSide() {
	female_side = inputParams[154];
}

/*
 * 'Mouse()' - Handle mouse button events.
 */

void
Mouse(int button, /* I - Button that changed */
      int state,  /* I - Current button states */
      int x,      /* I - Current mouse X position */
      int y)      /* I - Current mouse Y position */
{
	switch (button)	{
		case GLUT_LEFT_BUTTON:
		
		if (state == GLUT_DOWN) {
			if (stop) {
				glutPostRedisplay();
				// save old state:
				old_timeStep = timeStep;
				timeStep = -1;
				stop = 0;
			} else {
				timeStep = old_timeStep;
				glutPostRedisplay();
				stop = 1;
			}
		} 
	}
}

// Performance Measurements for fps:
// Timer callback function that measures the amount of time elasped between
// scene renders:
double time() {
    struct _timeb t;
	// get the current local system time:
    _ftime(&t);
    return ((double)t.time) + 0.001*((double)t.millitm);
}

void timing(int value) {
    glutTimerFunc(DELAY, timing, 0);

    static double last = time();
    static unsigned long count = 0;
    if(++count % 100 == 0) {
        double now = time();
        printf("%f fps\n", 100.0 / (now - last));
        last = now;
    }
}

// mexFunction()
// Substitute for main() to interface Matlab GUI with Visual C++/Opengl rendering
// parameters:
//	nlhs - output number of elements
//  plhs - output parameters
//  nrhs - input number of elements (argc)
//  prhs - input parameters (*argv[])
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {

	HWND	hwnd;
	int		i;

	// copy all mex input parameters into a global array structure accessible
	// to other functions.
	for (i = 0; i < nrhs; i++) {
		inputParams[i] = mxGetScalar(prhs[i]);
	}

	numParams = nrhs;
	// Set all the parameters and dimensions of the spider geometry.
	setColors();
	setAmbienceColor();
	setDiffuseColor();
	setSpecularColor();
	setBackgroundColor();
	setAbdomenParams();
	setThoraxParams();
	setHeadParams();
	setLegParams();
	setTimeStep();
	setGender();
	setSide();

	// These are all calls to glut functions.
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH); 

	// If the "Spider" window is already created, just find the instance of it on
	// the screen.
	hwnd = FindWindow("GLUT", "Spider");
	if(hwnd != NULL)
		SetFocus(hwnd);
    else
		glutCreateWindow("Spider");

	glutReshapeFunc(ChangeSize);	// enable resizing of window
	glutMouseFunc(Mouse);			// detect mouse clicks 
	glutSpecialFunc(SpecialKeys);	// detect arrow key presses 
	glutDisplayFunc(RenderScene);	// render spider
	SetupRC();						// set up lighting	
	//	glutTimerFunc(DELAY, timing, 0);// Performance measurement
	glutMainLoop();
}

