function spider_gui(fcn)
% clf
    global fig;
	if nargin == 0
		fcn = 'buildGUI';
	end
    menu_callback='menu_callback';
switch fcn
case 'buildGUI'
    % makes sure that figure 1 is on top before clearing out the figure:
    figure(1);
    clf;
	% build the figure
    fig = figure(1);
    
    vars.myname = mfilename;
    set(figure(1), 'Units', 'points', ...
        'Color', [0.8 0.8 0.8], ...
        'MenuBar', 'none', ...
        'Name', 'Spider  GUI', ...
        'ToolBar', 'none', ...
        'NumberTitle', 'off', ...
        'Position', [100 100 500 400]);
    
	% Define the File menu
	filemenu = uimenu('Parent', fig, ...
        'Label', '&File', ...
        'Tag', 'FileMenu');
	uimenu('Parent', filemenu, ...
        'Callback', [menu_callback, ' FileLoad'], ...
        'Label', '&Load', ...
        'Tag', 'FileLoad');
	uimenu('Parent', filemenu, ...
        'Callback', [menu_callback, ' FileSave'], ...
        'Label', '&Save', ...
        'Tag', 'FileSave');
	uimenu('Parent', filemenu, ...
        'Callback', [menu_callback, ' FileExit'], ...
        'Label', '&Exit', ...
        'Tag', 'FileExit');

	% Define the View menu
	viewmenu = uimenu('Parent', fig, ...
        'Label', '&View', ...
        'Tag', 'ViewMenu');
    viewsubmenu = uimenu('Parent', viewmenu, ...
        'Label', '&Gender', ...
        'Tag', 'ViewGender');
    uimenu('Parent', viewsubmenu, ...
        'Callback', [menu_callback, ' ViewGender'], ...
        'Label', '&Female', ...
        'Tag', 'ViewFemale');
    uimenu('Parent', viewsubmenu, ...
        'Callback', [menu_callback, ' ViewGender'], ...
        'Label', '&Male', ...
        'Tag', 'ViewMale');
    
    viewsubmenu = uimenu('Parent', viewmenu, ...
        'Label', '&Species', ...
        'Tag', 'ViewSpecies');
    
	uimenu('Parent', viewsubmenu, ...
	    'Callback', [menu_callback, ' ViewSpecies'], ...
	    'Label', '&S. Duplex', ...
	    'Tag', 'duplex');
	uimenu('Parent', viewsubmenu, ...
	    'Callback', [menu_callback, ' ViewSpecies'], ...
	    'Label', '&S. Uetzi', ...
	    'Tag', 'uetzi');
	uimenu('Parent', viewsubmenu, ...
	    'Callback', [menu_callback, ' ViewSpecies'], ...
	    'Label', '&S. Stridulans', ...
	    'Tag', 'stridulans');
	uimenu('Parent', viewsubmenu, ...
	    'Callback', [menu_callback, ' ViewSpecies'], ...
	    'Label', '&S. Crassipes', ...
	    'Tag', 'crassipes');


	% Define the Edit menu
	editmenu = uimenu('Parent', fig, ...
        'Label', '&Edit', ...
        'Tag', 'EditMenu');
	editsubmenu = uimenu('Parent', editmenu, ...      
        'Label', '&Color', ...
        'Tag', 'EditColor');
    uimenu('Parent', editsubmenu, ...
        'Callback', [menu_callback, ' EditBodyColor'], ...
        'Label', '&Body Color', ...
        'Tag', 'EditBodyColor');
    uimenu('Parent', editsubmenu, ...
        'Callback', [menu_callback, ' EditLegsColor'], ...
        'Label', '&Legs Color', ...
        'Tag', 'EditLegsColor');
   
    editsubmenu = uimenu('Parent', editmenu, ...
        'Callback', [menu_callback, ' EditBackground'], ...
        'Label', '&Background', ...
        'Tag', 'EditBackground');
    editsubmenu = uimenu('Parent', editmenu, ...
        'Callback', [menu_callback, ' EditLighting'], ...
        'Label', '&Lighting', ...
        'Tag', 'EditLighting');
    uimenu('Parent', editsubmenu, ...
        'Callback', [menu_callback, ' EditAmbienceLighting'], ...
        'Label', '&Ambience Lighting', ...
        'Tag', 'EditAmbienceLighting');
    uimenu('Parent', editsubmenu, ...
        'Callback', [menu_callback, ' EditDiffuseLighting'], ...
        'Label', '&Diffuse Lighting', ...
        'Tag', 'EditDiffuseLighting');
    uimenu('Parent', editsubmenu, ...
        'Callback', [menu_callback, ' EditSpecLighting'], ...
        'Label', '&Specular Lighting', ...
        'Tag', 'EditSpecLighting');
    uimenu('Parent', editmenu, ...
        'Callback', [menu_callback, ' EditAdvanced'], ...
        'Label', '&Advanced', ...
        'Tag', 'EditAdvanced');

	% Define the Play menu
	playmenu = uimenu('Parent', fig, ...
        'Label', '&Play', ...
        'Tag', 'PlayMenu');
	uimenu('Parent', playmenu, ...
        'Callback', [menu_callback, ' PlayPlay'], ...
        'Label', '&Play', ...
        'Tag', 'PlayPlay');
	uimenu('Parent', playmenu, ...
        'Callback', [menu_callback, ' PlayStop'], ...
        'Label', '&Stop', ...
        'Tag', 'PlayStop');
    
    % listbox frame for selecting morphology components to modify
    uicontrol('Parent', fig, ...
        'style', 'frame', ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'position', [10 270 180 250]);
    % have listbox for all parameters:
    options{1} = 'leg pair 1(front)';
    options{2} = 'leg pair 2';
    options{3} = 'leg pair 3';
    options{4} = 'leg pair 4(back)';
    options{5} = 'head';
    options{6} = 'thorax';
    options{7} = 'abdomen';

    % options{9} = '';
    uicontrol('Parent', fig, ...
        'Style', 'text', ...
        'String', 'Morphology Traits', ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'Units', 'points', ...
        'Position', [30, 350, 70, 15]);
    uicontrol('Parent', fig, ...
        'style', 'listbox', ...
        'BackgroundColor', [1.0 1.0 1.0], ...
        'String', options, ...
        'position', [20 380 150 70], ...
        'Tag', 'Listbox1', ...
        'Value', 1);
    %    'callback', 'menu_callback ChooseParameter', ...
    uicontrol('Parent', fig, ...
        'Units', 'points', ...
        'Callback', 'menu_callback ChooseParameter', ...
        'Position', [30 250 70 15], ...
        'String', 'Select', ...
        'Style', 'pushbutton', ...
        'Tag', 'Button 1');
    % frame for morphology parameters
    uicontrol('Parent', fig, ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'style', 'frame', ...
        'position', [200 270 430 250]);


    % spline points go here:

    vars.spline1button = uicontrol('Parent', fig, ...
        'style', 'radiobutton',...
        'value', 1, ...
        'string','joint 1', ...
        'tag','splinegroup', ...
        'BackgroundColor', [0.8 0.8 0.8], ...
        'callback','menu_callback splinechoose', ...
        'position', [100 5 50 20]);
    vars.spline2button = uicontrol('Parent', fig, ...
        'style', 'radiobutton',...
        'value', 0, ...
        'string','joint 2', ...
        'tag','splinegroup', ...
        'BackgroundColor', [0.8 0.8 0.8], ...
        'callback','menu_callback splinechoose', ...
        'position', [150 5 50 20]);
    vars.spline3button = uicontrol('Parent', fig, ...
        'style', 'radiobutton',...
        'value', 0, ...
        'string','joint 3', ...
        'tag','splinegroup', ...
        'BackgroundColor', [0.8 0.8 0.8], ...
        'callback','menu_callback splinechoose', ...
        'position', [200 5 50 20]);
    vars.spline4button = uicontrol('Parent', fig, ...
        'style', 'radiobutton',...
        'value', 0, ...
        'string','joint 4', ...
        'tag','splinegroup', ...
        'BackgroundColor', [0.8 0.8 0.8], ...
        'callback','menu_callback splinechoose', ...
        'position', [250 5 50 20]);

    
    % Added 1/18/03
    vars.splineLbutton = uicontrol('Parent', fig, ...
        'style', 'radiobutton', ...
        'value', 1, ...
        'string', 'Right', ...
        'tag','side', ...
        'BackgroundColor', [0.8 0.8 0.8], ...
        'callback', 'menu_callback sidechoose', ...
        'position', [600 200 50 20]);
    vars.splineRbutton = uicontrol('Parent', fig, ...
        'style', 'radiobutton', ...
        'value', 0, ...
        'string', 'Left', ...
        'tag','side', ...
        'BackgroundColor', [0.8 0.8 0.8], ...
        'callback', 'menu_callback sidechoose', ...
        'position', [600 230 50 20]);
    vars.filename = uicontrol('Parent', fig, ...
        'style', 'edit',...
        'value', 0, ...
        'string','motionfile', ...
        'backgroundcolor', [1.0 1.0 1.0], ...
        'position', [475 5 100 20]);

  
    %make a control to stop the loop
    uicontrol('Parent', fig, ...
        'style','pushbutton',...
        'string','Quit', ...
        'position',[10 5 50 20], ...
        'callback',[menu_callback,' FileExit']);

   
    %load button
    uicontrol('Parent', fig, ...
        'style','pushbutton',...
        'string','Load', ...
        'position',[300 5 50 20], ...
        'callback',[menu_callback,' loadMotion']);

    %save button
    uicontrol('Parent', fig, ...
        'style','pushbutton',...
        'string','Save', ...
        'position',[350 5 50 20], ...
        'callback',[menu_callback,' saveMotion']);
    uicontrol('Parent', fig, ...
        'style', 'pushbutton', ...
        'string', 'Apply', ...
        'position', [400 5 50 20], ...
        'callback',[menu_callback, ' applySpline']);
    axes('Parent', fig, ...
        'Units', 'pixels', ...
        'Color', [1 1 1], ...
        'Position', [80 60 500 200], ...
        'Tag', 'Axes1', ...
        'XColor', [0 0 0], ...
        'YColor', [0 0 0], ...
        'ZColor', [0 0 0]);

    vars.splineIndex = 1; %always start with spline number 1
    %define spline variables
    vars.tmax = 2; % seconds.
    vars.NumControl = 25; %number of control points
    vars.FPS = 60; %frames/sec
    vars.ForceZeroSlope = 1 ;
    vars.AngleRange = 60 ;

    vars.t = linspace(0, vars.tmax, vars.NumControl) ;
    vars.tt = linspace(0, vars.tmax, vars.tmax*vars.FPS) ;
    %start with all zeros in control points
    vars.numSplines = 8 ; %Four different spline curves
    vars.y = zeros(length(vars.t),vars.numSplines);
    vars.yy = zeros(length(vars.tt),vars.numSplines);

    if vars.ForceZeroSlope
        cs = spline(vars.t,[0; vars.y(:,vars.splineIndex); 0]);
    else
        cs = spline(vars.t,vars.y(:,vars.splineIndex));
    end
    vars.yy(:,vars.splineIndex) = ppval(cs,vars.tt)';

    hold on
    vars.sp = plot(vars.tt,vars.yy(:,vars.splineIndex));
    vars.line1 = plot(vars.t,vars.y(:,vars.splineIndex),'or');
    set(gca, 'ylim', [0 vars.AngleRange])
    vars.mousedown = 0; %init to no mouse click
    
    % do some initial loading incase nothing is loaded yet.
    fid = fopen('spider.txt');

    % Tokenizing allows skipping of commented lines     
    count = 1;
    while (feof(fid) == 0)
          txtline = fgetl(fid);
          
          % Check if this is a commented line.  Note: does not allow commenting to occur
          % in the middle of a line
          comment = findstr(txtline, '%');
          if (isempty(comment) ~= 1)
			  continue;
          end
          
          % how do you do reg exps?
		  if (isempty(deblank(txtline)))
			  continue;
		  end
          
          
          % we expect exactly 2 fields
          while (isempty(txtline) ~= 1)
              [variable, txtline] = strtok(txtline);
              [value, txtline] = strtok(txtline);

	          % cell arrays:  
			  % how come strtokenizing can't have white spaces at the end of lines?
			  % seems very odd if it's tokenizing according to the space delimiter
              vars.values{1, count} = str2num(value);
              vars.names{1, count} = variable;
			  
          end
          count = count + 1;
       end
       fclose(fid);
    vars.values{1,153} = vars.tmax*vars.FPS;
    vars.values{1,154} = 0; % male
    vars.values{1,155} = 1; % left side for female
    
    set(figure(1), 'userdata', vars);
        % start off with the leg parameter settings:
    spider_gui('build_leg1_text_boxes');
    %the mouse-click sets a flag for point aquisition
    set(fig, 'windowbuttondownfcn',...
        'set(figure(1),''windowbuttonmotionfcn'',''spider_gui update'');');
    set(fig, 'windowbuttonupfcn',...
        'set(figure(1),''windowbuttonmotionfcn'',[]);');
    % output = cmex(vars.values{1,:});
case 'update'
    vars = get(figure(1),'userdata');
    %get the mouse position in graph units
    mouse = get(gca,'currentpoint');
       
    % xaxis
    if ((mouse(1,1) <= vars.tmax) & (mouse(1,2) <= vars.AngleRange) & ...
            (mouse(1,1) >= 0) & (mouse(1,2) >= 0)) 
            
        %calculate the point nearest to the
        %mouse click
        lineX = get(vars.line1,'xdata');
        lineY = get(vars.line1,'ydata')';
        [val, pnt] = min(abs(lineX-mouse(1,1)));

        %move the control point on the plot and update control point vars
        lineY(pnt) = mouse(1,2);
        set(vars.line1, 'ydata', lineY);
        vars.y(:,vars.splineIndex) = lineY;
        
        %make new spline
        if vars.ForceZeroSlope
            cs = spline(vars.t,[0; lineY; 0]);
        else
            cs = spline(vars.t,lineY);
        end
        vars.yy(:,vars.splineIndex) = ppval(cs,vars.tt)';
        set(vars.sp, 'ydata', vars.yy(:,vars.splineIndex));
        set(gcf,'userdata',vars);
    end
case 'color_legs_slider'
    rgb_slider('Legs', 1, 2, 3, 0);
case 'color_slider'
    rgb_slider('', 1, 2, 3, 0);
case 'bg_color_slider'
    rgb_slider('Background', 16, 17, 18, 0);
case 'ambience_color_slider'
    rgb_slider('Ambience', 4, 5, 6, 7);
case 'diffuse_color_slider'   
    rgb_slider('Diffuse', 8, 9, 10, 11);
case 'spec_color_slider'
    rgb_slider('Specular', 12, 13, 14, 15);
case 'build_head_text_boxes'
    morph_gui('Head', 54, 55, 56);
case 'build_thorax_text_boxes'
    morph_gui('Thorax', 44, 45, 46);
case 'build_abdomen_text_boxes'
    morph_gui('Abdomen', 33, 34, 35);
case 'build_leg1_text_boxes'
    menu_callback = ['menu_callback ApplyIParams'];
    leg_gui('I', 57, 58, 59, 60, 61, 62, 63, 64,...
        69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80);
    buildApply(270, 210, 70, 15, menu_callback);

case 'build_leg2_text_boxes'
    menu_callback = ['menu_callback ApplyIIParams'];
    leg_gui('II', 81, 82, 83, 84, 85, 86, 87 ,88, ...
        93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104);  
    buildApply(270, 210, 70, 15, menu_callback);

case 'build_leg3_text_boxes'
    menu_callback = ['menu_callback ApplyIIIParams'];
    leg_gui('III', 105, 106, 107, 108, 109, 110, 111, 112, ...
        117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127, 128);
    buildApply(270, 210, 70, 15, menu_callback);

case 'build_leg4_text_boxes'
    menu_callback = ['menu_callback ApplyIVParams'];
    leg_gui('IV', 129, 130, 131, 132, 133, 134, 135, 136, ...
        141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152);
    buildApply(270, 210, 70, 15, menu_callback);

case 'edit_advanced'
    vars = get(figure(1), 'userdata');
    figure(2)
    clf
    figure(2)
    for i=1:length(vars.names)
        options{i} = vars.names{1,i};
    end
     set(figure(2), 'Color', [0.8 0.8 0.8], ...
       'Position', [300 300 257 200], ...
        'Name', 'Advanced Setting', ...
        'NumberTitle', 'off', ...
        'menubar', 'none', ...
        'Tag', 'Fig1');

    uicontrol('Parent', figure(2), ...
        'Style', 'text', ...
        'String', 'Parameter', ...
        'BackgroundColor', [0.8 0.8 0.8], ...
        'Units', 'points', ...
        'Position', [55, 120, 70, 15]);
    uicontrol('Parent', figure(2), ...
        'style', 'listbox', ...
        'BackgroundColor', [1.0 1.0 1.0], ...
        'String', options, ...
        'position', [50 105 150 50], ...
        'Tag', 'Listbox1', ...
        'callback', 'menu_callback ChooseAdvancedParameter', ...
        'Value', 1);
    
    uicontrol('Parent', figure(2), ...
        'style', 'edit', ...
        'BackgroundColor', [1 1 1], ...
        'String', vars.values{1,1}, ...
        'Position', [50 60 150 20], ...
        'Tag', 'TextBox1');
    uicontrol('Parent', figure(2), ...
        'Units', 'points', ...
        'Callback', 'menu_callback ApplyAdvancedParameter', ...
        'Position', [20 15 70 15], ...
        'String', 'Apply', ...
        'Style', 'pushbutton', ...
        'Tag', 'Button 1');
    uicontrol('Parent', figure(2), ...
        'Units', 'points', ...
        'Callback', 'menu_callback CancelColor', ...
        'Position', [100 15 70 15], ...
        'String', 'Cancel', ...
        'Style', 'pushbutton', ...
        'Tag', 'Button 2');

    % frame for morphology parameters
%    uicontrol('Parent', figure(2), ...
%        'BackgroundColor', [0.6 0.6 0.6], ...
%        'style', 'frame', ...
%        'position', [20 80 200 110]);

end


% -------------------- Subroutines begin here -----------------------------
% if param4 is 0, then only RGB slider is needed.  otherwise, need the alpha
% slider as well as RGB.  Parameters refer to the cell numbers that these
% variables are located in
function rgb_slider(name, param1, param2, param3, param4)
    fig = figure(1);
	vars = get(figure(1), 'userdata');
    get(figure(2));
    clf
    color_fig = figure(2);
    slider_title = [name, ' Slider'];
    menu_callback = ['menu_callback Apply', name, 'Color'];

    set(color_fig, 'Color', [0.8 0.8 0.8], ...
       'Position', [300 300 257 200], ...
        'Name', slider_title, ...
        'NumberTitle', 'off', ...
        'menubar', 'none', ...
        'Tag', 'Fig1');
    slider('Red', 150, 110, 110, vars.values{1,param1});
    slider('Green', 125, 90, 90, vars.values{1,param2});
    slider('Blue', 98, 70, 70, vars.values{1, param3});
    if (param4 ~= 0)
        slider('Alpha', 72, 50, 50, vars.values{1,param4});
        % position for apply and cancel buttons
        apply_pos = [50 20 70 17];
        cancel_pos = [140 20 70 17];
    else
        apply_pos = [50 40 70 17];
        cancel_pos = [140 40 70 17];
    end
    uicontrol('Parent', color_fig, ...
        'Callback', menu_callback, ...
        'String', 'Apply', ...
        'Position', apply_pos, ...
        'Style', 'pushbutton'); 
    uicontrol('Parent', color_fig, ...
        'Callback', 'menu_callback CancelColor', ...
        'String', 'Cancel', ...
        'Position', cancel_pos, ...
        'Style', 'pushbutton');

    vars = get(fig, 'userdata');
    set(color_fig, 'userdata', vars);
% end rgb_slider

% parameters measure the height of the slider in the figure
function slider(color, param1, param2, param3, cell_num)
    color_fig = figure(2);
    menu_callback = ['menu_callback ', color];
    uicontrol('Parent', color_fig, ...
        'style', 'text', ...
        'string', color, ...
        'BackgroundColor', [0.8 0.8 0.8], ...
        'position', [30 param1 30 17]);
    uicontrol('Parent', color_fig, ...
        'Units', 'points', ...
        'BackgroundColor', [0.8 0.8 0.8], ...
        'Position', [50 param2 70 17], ...
        'String', cell_num, ...
        'Style', 'text', ...
        'Tag', color);
    uicontrol('Parent', color_fig, ...
        'Units', 'points', ...
        'Callback', menu_callback, ...
        'Max', 1.00, ...
        'Min', 0, ...
        'Position', [110 param3 70 17], ...
        'String', color, ...
        'Style', 'slider', ...
        'Value', cell_num, ...
        'Tag', 'Popup1');
% end slider

% param* control the parameter settings that's passed into opengl
function leg_gui(part, param1, param2, param3, param4, ...
    param5, param6, param7, param8, param9, param10, param11, ...
    param12, param13, param14, param15, param16, param17, param18, ...
    param19, param20)

    del('Param');
    fig = figure(1);
    vars = get(figure(1), 'userdata');

    % set parameter to its expected data type as input
    param1 = num2str(vars.values{1, param1});
    param2 = num2str(vars.values{1, param2});
    param3 = num2str(vars.values{1, param3});
    param4 = num2str(vars.values{1, param4});        
    param5 = num2str(vars.values{1, param5});
    param6 = num2str(vars.values{1, param6});        
    param7 = num2str(vars.values{1, param7});
    param8 = num2str(vars.values{1, param8});
    
    title_parameter = ['Leg Pair ', part, ' Parameters'];
    lengthParam = ['Length'];
    radius = ['Radius'];
    vars = get(figure(1), 'userdata');
    buildTitle(250, 370, 100, 15, ['Leg Pair ', part, ' Parameters']);
    
    % title for each leg segment.  Leg segment 1 is closest to body 
    % while leg segment 4 is furthest from body.
    uicontrol('Parent', figure(1), ...
        'style', 'text', ...
        'string', 'Segment 1 (Closest to body)', ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'position', [265 470 60 15], ...
        'Tag', 'Param');
    uicontrol('Parent', figure(1), ...
        'style', 'text', ...
        'string', 'Segment 2', ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'position', [355 470 60 15], ...
        'Tag', 'Param');
    uicontrol('Parent', figure(1), ...
        'style', 'text', ...
        'string', 'Segment 3', ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'position', [445 470 60 15], ...
        'Tag', 'Param');
    uicontrol('Parent', figure(1), ...
        'style', 'text', ...
        'string', 'Segment 4 (furthest from body)', ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'position', [535 470 60 15], ...
        'Tag', 'Param');
    
    % Builds Text boxes for radius and length parameters on legs.
    buildTextBox(180, 210, 330, 330, 30, 30, 15, 15, ...
        'length', param1);
    buildTextBox(180, 210, 310, 310, 30, 30, 15, 15, ...
        'radius', param5);
    buildTextBox(250, 280, 330, 330, 30, 30, 15, 15, ...
        'length', param2);
    buildTextBox(250, 280, 310, 310, 30, 30, 15, 15, ...
        'radius', param6);
    buildTextBox(320, 350, 330, 330, 30, 30, 15, 15, ...
        'length', param3);
    buildTextBox(320, 350, 310, 310, 30, 30, 15, 15, ...
        'radius', param7);
    buildTextBox(390, 420, 330, 330, 30, 30, 15, 15, ...
        'length', param4);
    buildTextBox(390, 420, 310, 310, 30, 30, 15, 15, ...
        'radius', param8);
    uicontrol('Parent', figure(1), ...
        'style', 'text', ...
        'string', 'Red', ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'position', [205 378 30 15], ...
        'Tag', 'Param');
    uicontrol('Parent', figure(1), ...
        'style', 'text', ...
        'string', 'Green', ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'position', [205 352 30 15], ...
        'Tag', 'Param');
    uicontrol('Parent', figure(1), ...
        'style', 'text', ...
        'string', 'Blue', ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'position', [205 325 30 15], ...
        'Tag', 'Param');

    rgb_leg_slider(['segI'], param9, param10, param11, 180, 200);
    rgb_leg_slider(['segII'], param12, param13, param14, 250, 270);
    rgb_leg_slider(['segIII'], param15, param16, param17, 320, 340);
    rgb_leg_slider(['segIV'], param18, param19, param20, 390, 410);
% end leg_gui

%  rgb_leg_slider('Leg Pair I', param3, param4, param5);
function rgb_leg_slider(name, param1, param2, param3, xTextPos, xSliderPos)
    fig = figure(1);
	vars = get(figure(1), 'userdata');

    slider_title = [name, ' Slider'];
    menu_callback = ['menu_callback Apply', name, 'Color'];
    leg_slider('Red', name, xTextPos, xSliderPos, ...
        280, 280, 20, 50, 15, 15, param1);
    leg_slider('Green', name, xTextPos, xSliderPos, ...
        260, 260, 20, 50, 15, 15, param2);
    leg_slider('Blue', name, xTextPos, xSliderPos, ...
        240, 240, 20, 50, 15, 15, param3);
    vars = get(fig, 'userdata');
    set(fig, 'userdata', vars);
% end rgb_leg_slider

% parameters measure the height of the slider in the figure
function leg_slider(color, part, xTextPos, xSliderPos, yTextPos, ySliderPos, ...
    textWidth, sliderWidth, textHeight, sliderHeight, cell_num)
    fig = figure(1);
    vars = get(figure(1), 'userdata');
    
    cell_value = num2str(vars.values{1, cell_num});
    
    menu_callback = ['menu_callback ', [color, part]];
    uicontrol('Parent', fig, ...
        'Units', 'points', ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'Position', [xTextPos yTextPos textWidth textHeight], ...
        'String', cell_value, ...
        'Style', 'text', ...
        'Tag', [color, part]);
    uicontrol('Parent', fig, ...
        'Units', 'points', ...
        'Callback', menu_callback, ...
        'Max', 1.00, ...
        'Min', 0, ...
        'Position', [xSliderPos, ySliderPos, sliderWidth, sliderHeight], ...
        'String', [color part], ...
        'Style', 'slider', ...
        'Value', str2num(cell_value), ...
        'Tag', 'Param');
% end slider

% end rgb_leg_slider

function morph_gui(part, param1, param2, param3)
    del('Param');
    fig = figure(1);
    widthParam = ['Width'];
    lengthParam = ['Length'];
    heightParam = ['Height'];
    menu_callback = ['menu_callback Apply', part, 'Params'];
    
    vars = get(figure(1), 'userdata');
    buildTitle(260, 360, 100, 15, [part, ' Parameter']);
    buildTextBox(260, 310, 340, 340, 30, 50, 15, 15, ...
       'width', num2str(vars.values{1,param1}));
    buildTextBox(260, 310, 320, 320, 30, 50, 15, 15, ...
        'height', num2str(vars.values{1,param2}));
    buildTextBox(260, 310, 300, 300, 30, 50, 15, 15, ...
        'length',  num2str(vars.values{1,param3}));

    uicontrol('Parent', fig, ...
        'Units', 'points', ...
        'Callback', menu_callback, ...
        'String', 'Apply', ...
        'Position', [270 270 70 15], ...
        'Style', 'pushbutton', ...
        'Tag', 'Param');
% end morph_gui

function buildTitle(xPos, yPos, width, height, title_parameter)
    uicontrol('Parent', figure(1), ...
        'Style', 'text', ...
        'String', title_parameter, ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'Units', 'points', ...
        'Position', [xPos, yPos, width, height], ...
        'Tag', 'Param');
% end buildTitle

function buildApply(xPos, yPos, width, height, menu_callback)
    uicontrol('Parent', figure(1), ...
        'Units', 'points', ...
        'Callback', menu_callback, ...
        'String', 'Apply', ...
        'Position', [xPos, yPos, width, height], ...
        'Style', 'pushbutton', ...
        'Tag', 'Param');
% end buildApply

function buildTextBox(xTextPos, xBoxPos, yTextPos, yBoxPos, ...
    textWidth, boxWidth, textHeight, boxHeight, textName, boxName)
    
    uicontrol('Parent', figure(1), ...
        'Style', 'text', ...
        'String', textName, ...
        'BackgroundColor', [0.6 0.6 0.6], ...
        'HorizontalAlignment', 'Center', ...
        'Units', 'points', ...
        'Position', [xTextPos yTextPos textWidth textHeight], ...
        'Tag', 'Param');
    uicontrol('Parent', figure(1), ...
        'Units', 'points', ...
        'HorizontalAlignment', 'Center', ...
        'BackgroundColor', [1.0 1.0 1.0], ...
        'Position', [xBoxPos yBoxPos boxWidth boxHeight], ...
        'String', boxName, ...
        'Style', 'edit', ...
        'Tag', textName);
% end buildTextBox

% delete all possible tags in the parameter window:
function del(param)
    delete(findobj('Tag', param));
    delete(findobj('Tag', 'width'));
    delete(findobj('Tag', 'length'));
    delete(findobj('Tag', 'height'));
    delete(findobj('Tag', 'Red'));
    delete(findobj('Tag', 'Green'));
    delete(findobj('Tag', 'Blue'));
    delete(findobj('Tag', 'radius'));
    delete(findobj('Tag', 'RedsegI'));
    delete(findobj('Tag', 'GreensegI'));
    delete(findobj('Tag', 'BluesegI'));
    delete(findobj('Tag', 'RedsegII'));
    delete(findobj('Tag', 'GreensegII'));
    delete(findobj('Tag', 'BluesegII'));
    delete(findobj('Tag', 'RedsegIII'));
    delete(findobj('Tag', 'GreensegIII'));
    delete(findobj('Tag', 'BluesegIII'));
    delete(findobj('Tag', 'RedsegIV'));
    delete(findobj('Tag', 'GreensegIV'));
    delete(findobj('Tag', 'BluesegIV'));

% end del

function splinePts(spline1button, spline2button, spline3button, spline4button)
    fig = figure(1);
    vars = get(figure(1), 'userdata');

    set(fig, 'userdata', vars);
% end splinePts